<template>
    <div>
        <section class="accordions">
            <!--
                <article class="accordion">
                    <div class="accordion-header toggle">
                    </div>
                    <div class="accordion-body">
                        <div class="accordion-content">
                            <div class="field" v-if="loaded">
                                <label for="">
                                </label>
                                <div class="control">
                                    <input id="" class="input" v-model="json">
                                </div>
                            </div>
                        </div>
                    </div>
                </article>
            -->
            <article class="accordion is-active">
                <div class="accordion-header toggle">
                    {{ $t('Your instance') }}
                </div>
                <div class="accordion-body">
                    <div class="accordion-content">
                        <div class="field" v-if="loaded">
                            <label for="hostname" class="label" v-html="$t('Web address of your Tiny Tiny RSS instance (without {{- opentag}}http(s)://{{- endtag}})', { opentag: openCode, endtag: endCode })">
                            </label>
                            <div class="control">
                                <input id="hostname" class="input" v-model="json.hostname" :placeholder="json.hostname">
                            </div>
                        </div>
                        <div class="field" v-if="loaded">
                            <label for="threads" class="label" v-html="$t('How many CPU threads should be allocated to the update daemon?')">
                            </label>
                            <div class="control">
                                <input id="threads" class="input" v-model.number="json.threads" type="number" min="1" step="1">
                            </div>
                        </div>
                    </div>
                </div>
            </article>
            <article class="accordion">
                <div class="accordion-header toggle">
                    {{ $t('Setting up email sending') }}
                </div>
                <div class="accordion-body">
                    <div class="accordion-content">
                        <div class="field" v-if="loaded">
                            <label for="smtp_from_name" class="label">
                                {{ $t('Display name of the email’s sender') }}
                            </label>
                            <div class="control">
                                <input id="smtp_from_name" class="input" v-model="json.smtp.from_name">
                            </div>
                        </div>
                        <div class="field" v-if="loaded">
                            <label for="smtp_from_address" class="label">
                                {{ $t('Email sender address') }}
                            </label>
                            <div class="control">
                                <input id="smtp_from_address" class="input" v-model="json.smtp.from_address">
                            </div>
                        </div>
                        <div class="field" v-if="loaded">
                            <label for="smtp_digest_subject" class="label">
                                {{ $t('Subject of digest emails') }}
                            </label>
                            <div class="control">
                                <input id="smtp_digest_subject" class="input" v-model="json.smtp.digest_subject">
                            </div>
                        </div>
                    </div>
                </div>
            </article>
            <article class="accordion">
                <div class="accordion-header toggle">
                    {{ $t('Registrations') }}
                </div>
                <div class="accordion-body">
                    <div class="accordion-content">
                        <div class="field" v-if="loaded">
                            <label class="checkbox">
                                <input v-model="json.registration.activated" type="checkbox">
                                {{ $t('Open registrations?') }}
                            </label>
                        </div>
                        <div v-if="loaded && json.registration.activated">
                            <div class="field" v-if="loaded">
                                <label for="registration_accounts_number" class="label" v-html="$t('Maximum number of accounts (when this number is reached, registrations are disabled. For an unlimited number of accounts, put {{- opentag}}0{{- endtag}})', { opentag: openCode, endtag: endCode })">
                                </label>
                                <div class="control">
                                    <input id="registration_accounts_number" class="input" v-model.number="json.registration.accounts_number" type="number" min="0" step="1">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </article>
            <article class="accordion">
                <div class="accordion-header toggle">
                    {{ $t('Admin account') }}
                </div>
                <div class="accordion-body">
                    <div class="accordion-content">
                        <p v-html="$t('The login of the admin account is, without surprise, {{- opentag}}admin{{- endtag}}.', { opentag: openCode, endtag: endCode })">
                        </p>
                        <div class="field" v-if="loaded">
                            <label for="admin_email" class="label">
                                {{ $t('Email attached to admin account') }}
                            </label>
                            <div class="control">
                                <input id="admin_email" class="input" v-model="json.admin.email">
                            </div>
                        </div>
                        <div class="field" v-if="loaded">
                            <label for="admin_password" class="label">
                                {{ $t('Password of admin account') }}
                            </label>
                            <div class="control">
                                <input id="admin_password" class="input" v-model="json.admin.password">
                            </div>
                        </div>
                    </div>
                </div>
            </article>
            <article class="accordion">
                <div class="accordion-header toggle">
                    Apticron
                </div>
                <div class="accordion-body">
                    <div class="accordion-content">
                        <p>
                            {{ $t('Apticron is a program that runs daily on your server and notifies you by email if package updates are available.') }}
                        </p>
                        <div class="field" v-if="loaded">
                            <label class="checkbox">
                                <input v-model="json.apticron.enabled" type="checkbox">
                                <span v-html="' ' + $t('Install apticron? {{- opentag}}recommended{{- endtag}}', { opentag: openSuccessSpan, endtag: endSpan })"></span>
                            </label>
                        </div>
                        <div v-if="loaded && json.apticron.enabled">
                            <div class="field" v-if="loaded">
                                <label for="apticron_email" class="label" v-html="$t('Recipient for apticron’s emails ({{- opentag}}root{{- endtag}} is ok if you configured a real address in {{- opentag}}/etc/aliases{{- endtag}}', { opentag: openCode, endtag: endCode })">
                                </label>
                                <div class="control">
                                    <input id="apticron_email" class="input" v-model="json.apticron.email">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </article>
        </section>
        <div class="buttons">
            <a :href="pillar" class="button is-info" download="ttrss.yml">
                {{ $t('Download configuration') }}
            </a>
            <button class="button is-info" v-on:click="loadConfFromServer">
                {{ $t('Reset') }}
            </button>
        </div>
    </div>
</template>

<script>
import axios from 'axios'
import bulmaAccordion from '../../node_modules/bulma-extensions/bulma-accordion/dist/js/bulma-accordion.min.js'
let yaml = require('js-yaml')
export default {
    name: 'Form',
    data() {
        return {
            json: {},
            loaded: false,
            openCode: '<code>',
            endCode: '</code>',
            openSuccessSpan: '<span class="tag is-success">',
            endSpan: '</span>',
            accordions: []
        }
    },
    computed: {
        yml: function() {
            return yaml.safeDump({ ttrss: { my_server: this.json } }, { sortKeys: true })
        },
        pillar: function() {
            return window.URL.createObjectURL(
                new Blob([this.yml], { type : 'application/x-yaml' })
            );
        }
    },
    created() {
        this.loadConfFromServer()
    },
    mounted() {
        this.accordions = bulmaAccordion.attach()
    },
    methods: {
        loadConfFromServer: function () {
            axios.get('pillar.sls')
                .then(response => {
                    this.loaded = true
                    this.json   = yaml.safeLoad(response.data).ttrss.my_server
                })
        }
    }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="sass">
.buttons
    margin-top: 10px
.buttons .button
    margin-right: 3px
</style>
